import { Pipe, PipeTransform } from '@angular/core';
import { AuditSymbol } from '../models/audit-symbols';

@Pipe({ name: 'courseNote' })
export class CourseNotePipe implements PipeTransform {
    transform(notes: string | null): AuditSymbol[] {
        if (notes === null) {
            return [];
        }

        const symbols: AuditSymbol[] = [
            { type: 'text', text: '>D', tooltip: 'Duplicate course - retains GPA effect' },
            { type: 'text', text: '>R', tooltip: 'Repeatable course' },
            { type: 'text', text: '>S', tooltip: 'Credit split between requirements' },
            { type: 'text', text: '>X', tooltip: 'Repeated course - no course credit or GPA effect' },
            { type: 'text', text: '(R)', tooltip: 'Required course' },
            { type: 'text', text: '(X)', tooltip: 'Original course value' },
        ];

        return symbols.reduce((acc, symbol) => {
            return notes.includes(symbol.text) ? [...acc, symbol] : acc;
        }, []);
    }
}
